
import java.util.HashMap;
import java.util.Map;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.api.jms.JMSFactoryType;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;
import org.hornetq.core.remoting.impl.netty.TransportConstants;

import org.hornetq.api.core.DiscoveryGroupConfiguration;
import org.hornetq.api.core.client.loadbalance.RandomStickyConnectionLoadBalancingPolicy;
import org.hornetq.jms.client.HornetQConnectionFactory;


import javax.management.MBeanServerConnection;
import javax.management.MBeanServerInvocationHandler;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;

import org.hornetq.api.core.management.MessageCounterInfo;
import org.hornetq.api.core.management.ObjectNameBuilder;
import org.hornetq.api.jms.management.JMSQueueControl;

public class QueueStats
{
    public static void main(String[] args) throws Exception
    {
        String server_host = args[0];
        String queue_name = args[1];
        String JMX_URL = "service:jmx:rmi:///jndi/rmi://" + server_host + ":3001/jmxrmi";

        ObjectName on = ObjectNameBuilder.DEFAULT.getJMSQueueObjectName(queue_name);
        JMXConnector connector = JMXConnectorFactory.connect(new JMXServiceURL(JMX_URL), new HashMap());
        MBeanServerConnection mbsc = connector.getMBeanServerConnection();
        JMSQueueControl queueControl = (JMSQueueControl)
                        MBeanServerInvocationHandler.newProxyInstance(mbsc, on,
                                                          JMSQueueControl.class, false);

        String counters = queueControl.listMessageCounter();
        MessageCounterInfo messageCounter = MessageCounterInfo.fromJSON(counters);

        System.out.println("counters var is: " + counters);
        System.out.println("count var is: " + messageCounter.getCount());
        System.out.println("countdelta var is: " + messageCounter.getCountDelta());
        System.out.println("depth var is: " + messageCounter.getDepth());
        System.out.println("depthdelta var is: " + messageCounter.getDepthDelta());
        System.out.println("last add var is: " + messageCounter.getLastAddTimestamp() );

    }
}


